Appearance in JavaScript Block Editor control

18 Nov 20181 minute to read

The Block Editor control provides several properties to customize its visual appearance, allowing you to control its dimensions, styling, and behavior.

Setting width and height

You can specify the width and height for the Block Editor control using the width and height properties.

const editor = new BlockEditor({
    width: '100%',
    height: '80vh'
});

// Or with specific pixel values
const editor = new BlockEditor({
    width: '800px',
    height: '500px'
});

Setting readonly mode

You can utilize the readOnly property to control whether the editor is in read-only mode. When set to true, users cannot edit the content but can still view it.

const editor = new BlockEditor({
    readOnly: true
});

Customization using CSS Class

You can use the cssClass property to customize the appearance of the Block Editor control.

const editor = new BlockEditor({
    width: '600px',
    height: '400px',
    cssClass: 'custom-editor-theme'
});

The following example demonstrates the usage of readOnly and cssClass properties of the Block Editor.

Appearance in Angular Block Editor component

18 Nov 201814 minutes to read

The Block Editor component provides several properties to customize its visual appearance, allowing you to control its dimensions, styling, and behavior.

Setting width and height

You can specify the width and height for the Block Editor component using the width and height properties.

<ejs-blockeditor [width]="'100%'" [height]="'80vh'" />

// Or with specific pixel values
<ejs-blockeditor [width]="'800px'" [height]="'500px'" />

Setting readonly mode

You can utilize the readOnly property to control whether the editor is in read-only mode. When set to true, users cannot edit the content but can still view it.

<ejs-blockeditor [readOnly]="true" />

Customization using CSS Class

You can use the cssClass property to customize the appearance of the Block Editor control.

<ejs-blockeditor [width]="'600px'" [height]="'400px'" [cssClass]="'custom-editor-theme'" />

The following example demonstrates the usage of readOnly and cssClass properties of the Block Editor.

import { Component, ViewChild } from '@angular/core';
import { BlockEditorModule, BlockEditorComponent } from "@syncfusion/ej2-angular-blockeditor";
import { BlockModel, ContentType} from "@syncfusion/ej2-blockeditor";

@Component({
    imports: [BlockEditorModule],
    standalone: true,
    selector: 'app-root',
    templateUrl: './app.component.html'
})


export class AppComponent {
    @ViewChild('blockEditorComponent')
    public blockEditorComponent!: BlockEditorComponent;
    output = '';
    statusMessage = '';
    isReadonly = false;
    currentTheme = 'default';
    public blocksData: BlockModel[] = [
        {
            blockType: 'Heading',
            properties: { level: 1 },
            content: [
                {
                    contentType: ContentType.Text,
                    content: 'Appearance Configuration Demo'
                }
            ]
        },
        {
            blockType: 'Paragraph',
            content: [
                {
                    contentType: ContentType.Text,
                    content: 'This demo showcases different appearance configurations including readonly mode and a custom CSS theme.'
                }
            ]
        },
        {
            blockType: 'Heading',
            properties: { level: 2 },
            content: [
                {
                    contentType: ContentType.Text,
                    content: 'Configured Custom Theme'
                }
            ]
        },
        {
            blockType: 'BulletList',
            content: [
                {
                    contentType: ContentType.Text,
                    content: 'Gradient background with modern styling'
                }
            ]
        },
        {
            blockType: 'Paragraph',
            content: [
                {
                    contentType: ContentType.Text,
                    content: 'Use the readonly toggle to switch between editable and read-only modes. In readonly mode, you can view content but cannot make changes.'
                }
            ]
        }
    ];
    // Toggle Readonly Mode
    public toggleReadonly = () => {
        this.isReadonly = !this.isReadonly;
        this.blockEditorComponent.readOnly = this.isReadonly;

        // Add visual indication for readonly mode
        const editorElement = document.getElementById('blockeditor');
        if (editorElement) {
            if (this.isReadonly) {
                editorElement.classList.add('readonly-mode');
            } else {
                editorElement.classList.remove('readonly-mode');
            }
        }

        this.updateStatus();
        this.displayOutput(`Readonly mode ${this.isReadonly ? 'enabled' : 'disabled'}. ${this.isReadonly ? 'Content is now view-only.' : 'Content is now editable.'}`);
    }   
    // Apply Custom Theme
    public applyCustomTheme = () => {
        this.blockEditorComponent.cssClass = 'custom-theme';
        this.currentTheme = 'custom';
        this.updateStatus();
        this.displayOutput('Custom theme applied. The editor now features a gradient background with modern styling and hover effects.');
    }
    // Add event listeners for editor interactions
    public onEditorFocus = () => {
        this.displayOutput('Editor focused. You can now type or edit content.');
    }
    public onEditorBlur = () => {
        this.displayOutput('Editor lost focus.');
    }
    // Initialize status display
    ngOnInit(): void {
        this.updateStatus();
    }

    // Output helper function
    displayOutput(msg: string): void {
        this.output = msg;
    }

    // Update status display
    updateStatus(): void {
        const mode = this.isReadonly ? 'Readonly' : 'Editable';
        const theme = this.currentTheme === 'default' ? 'Default' : 'Custom';
        this.statusMessage = `${mode}, ${theme} Theme`;
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
<div id="container">
    <ejs-blockeditor id="blockeditor" #blockEditorComponent [blocks]="blocksData" [cssClass]="currentTheme" [readOnly]="isReadonly" (focus)="onEditorFocus()" (blur)="onEditorBlur()" />
    <div id="controls">
        <h3>Appearance Configuration Demo</h3>
        <div class="button-group">
            <button (click)="toggleReadonly()">Toggle Readonly Mode</button>
            <button (click)="applyCustomTheme()">Apply Custom Theme</button>
        </div>
        <div id="statusText" style="margin-top: 10px;">
            <strong>Current Status: </strong>
        </div>
    </div>
    <div id="output"></div>
</div>
/* You can add global styles to this file, and also import other style files */
@import "node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import 'node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import 'node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import 'node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import 'node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import 'node_modules/@syncfusion/ej2-lists/styles/tailwind3.css';
@import 'node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import 'node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
@import 'node_modules/@syncfusion/ej2-angular-blockeditor/styles/tailwind3.css';

#container {
    margin: 50px;
    gap: 20px;
    display: flex;
    flex-direction: column;
    align-items: center;
}

#controls {
    margin-bottom: 20px;
    padding: 20px;
    border: 1px solid #ddd;
    border-radius: 5px;
    background-color: #f8f9fa;
}

.button-group {
    margin-bottom: 15px;
}

.button-group button {
    margin: 5px;
    padding: 8px 16px;
    background-color: #17a2b8;
    color: white;
    border: none;
    border-radius: 4px;
    cursor: pointer;
}

.button-group button:hover {
    background-color: #138496;
}

.status-info {
    padding: 10px;
    background-color: #d1ecf1;
    border-left: 4px solid #17a2b8;
    border-radius: 4px;
}

.status-info p {
    margin: 0;
    color: #0c5460;
}

#output {
    margin-top: 15px;
    padding: 10px;
    background-color: #f8f9fa;
    border-radius: 4px;
    min-height: 50px;
    font-family: monospace;
    white-space: pre-wrap;
}

/* Custom Theme CSS Class */
.custom-theme {
    background: linear-gradient(135deg, #667eea 0%, #764ba2 100%);
    border-radius: 12px;
}

.custom-theme .e-block {
    border-radius: 8px;
    margin-bottom: 10px;
    backdrop-filter: blur(10px);
}

.custom-theme .e-block:hover {
    transform: translateY(-2px);
    transition: all 0.3s ease;
}

.custom-theme .e-block-content, .custom-theme .e-floating-icon {
    color: #fff;
    font-weight: 500;
}

/* Readonly Mode Styling */
.readonly-mode {
    opacity: 0.8;
    cursor: not-allowed;
}

.readonly-mode .e-block-content {
    color: #6c757d;
}

.custom-theme.readonly-mode .e-block-content {
    color: #101111;
}

Appearance in React Block Editor component

18 Nov 201820 minutes to read

The Block Editor component provides several properties to customize its visual appearance, allowing you to control its dimensions, styling, and behavior.

Setting width and height

You can specify the width and height for the Block Editor component using the width and height properties.

<BlockEditorComponent width="100%" height="80vh"></BlockEditorComponent>

// Or with specific pixel values
<BlockEditorComponent width="800px" height="500px"></BlockEditorComponent>

Setting readonly mode

You can utilize the readOnly property to control whether the editor is in read-only mode. When set to true, users cannot edit the content but can still view it.

<BlockEditorComponent readonly={true}></BlockEditorComponent>

Customization using CSS Class

You can use the cssClass property to customize the appearance of the Block Editor control.

<BlockEditorComponent width="600px" height="400px" cssClass="custom-editor-theme"></BlockEditorComponent>

The following example demonstrates the usage of readOnly and cssClass properties of the Block Editor.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { useRef, useState, useEffect } from 'react';
import { BlockEditorComponent, ContentType } from '@syncfusion/ej2-react-blockeditor';

function App() {
  const blockData = [
    {
      blockType: 'Heading',
      properties: { level: 1},
      content: [{ contentType: ContentType.Text, content: 'Appearance Configuration Demo' }]
    },
    {
      blockType: 'Paragraph',
      content: [
        {
          contentType: ContentType.Text,
          content:
            'This demo showcases different appearance configurations including readonly mode and a custom CSS theme.'
        }
      ]
    },
    {
      blockType: 'Heading',
      properties: { level: 2},
      content: [{ contentType: ContentType.Text, content: 'Configured Custom Theme' }]
    },
    {
      blockType: 'BulletList',
      content: [{ contentType: ContentType.Text, content: 'Gradient background with modern styling' }]
    },
    {
      blockType: 'Paragraph',
      content: [
        {
          contentType: ContentType.Text,
          content:
            'Use the readonly toggle to switch between editable and read-only modes. In readonly mode, you can view content but cannot make changes.'
        }
      ]
    }
  ];

  const editorRef = useRef(null);
  const [isReadonly, setIsReadonly] = useState(false);
  const [currentTheme, setCurrentTheme] = useState('default');
  const outputRef = useRef(null);
  const statusTextRef = useRef(null);

  useEffect(() => {
    const toggleReadonlyBtn = document.getElementById('toggleReadonlyBtn');
    const applyCustomThemeBtn = document.getElementById('applyCustomThemeBtn');
    outputRef.current = document.getElementById('output');
    statusTextRef.current = document.getElementById('statusText');

    const toggleReadonly = () => {
      setIsReadonly((prev) => {
        const newMode = !prev;
        if (editorRef.current) {
          editorRef.current.readOnly = newMode;
          const el = document.getElementById('blockeditor');
          if (el) {
            if (newMode) el.classList.add('readonly-mode');
            else el.classList.remove('readonly-mode');
          }
        }
        if (outputRef.current) {
          outputRef.current.textContent = `Readonly mode ${newMode ? 'enabled' : 'disabled'}. ${
            newMode ? 'Content is now view-only.' : 'Content is now editable.'
          }`;
        }
        return newMode;
      });
      setTimeout(updateStatus, 0);
    };

    const applyCustomTheme = () => {
      if (editorRef.current) {
        editorRef.current.cssClass = 'custom-theme';
      }
      setCurrentTheme('custom');
      if (outputRef.current) {
        outputRef.current.textContent =
          'Custom theme applied. The editor now features a gradient background with modern styling and hover effects.';
      }
      updateStatus();
    };

    const updateStatus = () => {
      const mode = isReadonly ? 'Readonly' : 'Editable';
      const theme = currentTheme.charAt(0).toUpperCase() + currentTheme.slice(1);
      if (statusTextRef.current) {
        statusTextRef.current.textContent = `${mode}, ${theme} Theme`;
      }
    };

    if (toggleReadonlyBtn) {
      toggleReadonlyBtn.addEventListener('click', toggleReadonly);
    }
    if (applyCustomThemeBtn) {
      applyCustomThemeBtn.addEventListener('click', applyCustomTheme);
    }

    updateStatus();

    return () => {
      if (toggleReadonlyBtn) {
        toggleReadonlyBtn.removeEventListener('click', toggleReadonly);
      }
      if (applyCustomThemeBtn) {
        applyCustomThemeBtn.removeEventListener('click', applyCustomTheme);
      }
    };
  }, [isReadonly, currentTheme]);

  return (
    <div className='appearance'>
      <div id="controls">
        <h3>Appearance Configuration Demo</h3>
        <div className="button-group">
          <button id="toggleReadonlyBtn">Toggle Readonly Mode</button>
          <button id="applyCustomThemeBtn">Apply Custom Theme</button>
        </div>
        <div className="status-info">
          <p>
            <strong>Current Status:</strong>{' '}
            <span id="statusText">Editable, Default Theme</span>
          </p>
        </div>
      </div>

      <BlockEditorComponent
        id="blockeditor"
        ref={editorRef}
        blocks={blockData}
        focus={() => {
          if (outputRef.current) {
            outputRef.current.textContent = 'Editor focused. You can now type or edit content.';
          }
        }}
        blur={() => {
          if (outputRef.current) {
            outputRef.current.textContent = 'Editor lost focus.';
          }
        }}
      />

      <div id="output" ref={outputRef}></div>
    </div>
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById('container'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { useRef, useState, useEffect } from 'react';
import { BlockEditorComponent, BlockModel, ContentType } from '@syncfusion/ej2-react-blockeditor';

function App() {
  const blockData: BlockModel[] = [
    {
      blockType: 'Heading',
      properties: { level: 1},
      content: [{ contentType: ContentType.Text, content: 'Appearance Configuration Demo' }]
    },
    {
      blockType: 'Paragraph',
      content: [
        {
          contentType: ContentType.Text,
          content:
            'This demo showcases different appearance configurations including readonly mode and a custom CSS theme.'
        }
      ]
    },
    {
      blockType: 'Heading',
      properties: { level: 2},
      content: [{ contentType: ContentType.Text, content: 'Configured Custom Theme' }]
    },
    {
      blockType: 'BulletList',
      content: [{ contentType: ContentType.Text, content: 'Gradient background with modern styling' }]
    },
    {
      blockType: 'Paragraph',
      content: [
        {
          contentType: ContentType.Text,
          content:
            'Use the readonly toggle to switch between editable and read-only modes. In readonly mode, you can view content but cannot make changes.'
        }
      ]
    }
  ];

  const editorRef = useRef<BlockEditorComponent | null>(null);
  const [isReadonly, setIsReadonly] = useState<boolean>(false);
  const [currentTheme, setCurrentTheme] = useState<'default' | 'custom'>('default');
  const outputRef = useRef<HTMLDivElement | null>(null);
  const statusTextRef = useRef<HTMLSpanElement | null>(null);

  useEffect(() => {
    const toggleReadonlyBtn = document.getElementById('toggleReadonlyBtn');
    const applyCustomThemeBtn = document.getElementById('applyCustomThemeBtn');
    outputRef.current = document.getElementById('output') as HTMLDivElement | null;
    statusTextRef.current = document.getElementById('statusText') as HTMLSpanElement | null;

    const toggleReadonly = () => {
      setIsReadonly((prev) => {
        const newMode = !prev;
        if (editorRef.current) {
          editorRef.current.readOnly = newMode;
          const el = document.getElementById('blockeditor');
          if (el) {
            if (newMode) el.classList.add('readonly-mode');
            else el.classList.remove('readonly-mode');
          }
        }
        if (outputRef.current) {
          outputRef.current.textContent = `Readonly mode ${newMode ? 'enabled' : 'disabled'}. ${
            newMode ? 'Content is now view-only.' : 'Content is now editable.'
          }`;
        }
        return newMode;
      });
      setTimeout(updateStatus, 0);
    };

    const applyCustomTheme = () => {
      if (editorRef.current) {
        editorRef.current.cssClass = 'custom-theme';
      }
      setCurrentTheme('custom');
      if (outputRef.current) {
        outputRef.current.textContent =
          'Custom theme applied. The editor now features a gradient background with modern styling and hover effects.';
      }
      updateStatus();
    };

    const updateStatus = () => {
      const mode = isReadonly ? 'Readonly' : 'Editable';
      const theme = currentTheme.charAt(0).toUpperCase() + currentTheme.slice(1);
      if (statusTextRef.current) {
        statusTextRef.current.textContent = `${mode}, ${theme} Theme`;
      }
    };

    if (toggleReadonlyBtn) {
      toggleReadonlyBtn.addEventListener('click', toggleReadonly);
    }
    if (applyCustomThemeBtn) {
      applyCustomThemeBtn.addEventListener('click', applyCustomTheme);
    }

    updateStatus();

    return () => {
      if (toggleReadonlyBtn) {
        toggleReadonlyBtn.removeEventListener('click', toggleReadonly);
      }
      if (applyCustomThemeBtn) {
        applyCustomThemeBtn.removeEventListener('click', applyCustomTheme);
      }
    };
  }, []);

  return (
    <div className="appearance">
      <div id="controls">
        <h3>Appearance Configuration Demo</h3>
        <div className="button-group">
          <button id="toggleReadonlyBtn">Toggle Readonly Mode</button>
          <button id="applyCustomThemeBtn">Apply Custom Theme</button>
        </div>
        <div className="status-info">
          <p>
            <strong>Current Status:</strong>{' '}
            <span id="statusText">Editable, Default Theme</span>
          </p>
        </div>
      </div>

      <BlockEditorComponent
        id="blockeditor"
        ref={editorRef}
        blocks={blockData}
        focus={() => {
          if (outputRef.current) {
            outputRef.current.textContent = 'Editor focused. You can now type or edit content.';
          }
        }}
        blur={() => {
          if (outputRef.current) {
            outputRef.current.textContent = 'Editor lost focus.';
          }
        }}
      />

      <div id="output"></div>
    </div>
  );
}

export default App;
ReactDOM.render(<App />, document.getElementById('container'));

Appearance in Vue Block Editor component

18 Nov 201814 minutes to read

The Block Editor component provides several properties to customize its visual appearance, allowing you to control its dimensions, styling, and behavior.

Setting width and height

You can specify the width and height for the Block Editor component using the width and height properties.

Setting readonly mode

You can utilize the readOnly property to control whether the editor is in read-only mode. When set to true, users cannot edit the content but can still view it.

Customization using CSS Class

You can use the cssClass property to customize the appearance of the Block Editor control.

<template>
  <div id='container'>
    <ejs-blockeditor id="blockeditor" :blocks="blocksData" ref="blockEditor" @focus="focusEvent" @blur="blurEvent"></ejs-blockeditor>
    <div id="controls">
            <h3>Appearance Configuration Demo</h3>
            <div class="button-group">
                <button @click="toggleReadonly">Toggle Readonly Mode</button>
                <button @click="applyCustomTheme">Apply Custom Theme</button>
            </div>
            <div class="status-info">
                <p><strong>Current Status:</strong> <span id="statusText">Editable, Default Theme</span></p>
            </div>
        </div>
    <div id="output"></div>
  </div>
</template>

<script setup>
import { BlockEditorComponent as EjsBlockeditor, ContentType } from "@syncfusion/ej2-vue-blockeditor";

const blockData = [
    {
          blockType: 'Heading',
          properties: { level: 1},          
          content: [{ contentType: ContentType.Text, content: 'Appearance Configuration Demo' }],
        },
        {
          blockType: 'Paragraph',
          content: [{ contentType: ContentType.Text, content: 'This demo showcases different appearance configurations including readonly mode and a custom CSS theme.' }],
        },
        {
          blockType: 'Heading',
          properties: { level: 2},
          content: [{ contentType: ContentType.Text, content: 'Configured Custom Theme' }],
        },
        {
          blockType: 'BulletList',
          content: [{ contentType: ContentType.Text, content: 'Gradient background with modern styling' }],
        },
        {
          blockType: 'Paragraph',
          content: [{ contentType: ContentType.Text, content: 'Use the readonly toggle to switch between editable and read-only modes. In readonly mode, you can view content but cannot make changes.' }],
        }
];

const isReadonly = false;
const currentTheme = 'default';

const toggleReadonlyMode = () => {
  isReadonly.value = !isReadonly.value;
  const editorElement = document.getElementById('blockeditor');
  if (editorElement) {
    if (isReadonly.value) {
      editorElement.classList.add('readonly-mode');
    } else {
      editorElement.classList.remove('readonly-mode');
    }
  }
  updateStatus();
  displayOutput(`Readonly mode ${isReadonly ? 'enabled' : 'disabled'}. ${isReadonly ? 'Content is now view-only.' : 'Content is now editable.'}`);
};

const applyCustomTheme = () => {
  const blockEditor = document.getElementById('blockeditor');
  blockEditor.classList.toggle('custom-theme');
  currentTheme.value = 'custom';
  updateStatus();
  displayOutput('Custom theme applied. The editor now features a gradient background with modern styling and hover effects.');
};

const focusEvent= () => {
  displayOutput('Editor focused. You can now type or edit content.');
},
const blurEvent= () => {
    displayOutput('Editor lost focus.');
},

const displayOutput = (message) => {
  var outputDiv = document.getElementById('output');
    if (outputDiv) {
        outputDiv.textContent = message;
    }
};

const updateStatus = () => {
    var statusText = document.getElementById('statusText');
    if (statusText) {
        var mode = isReadonly ? 'Readonly' : 'Editable';
        var theme = currentTheme.charAt(0).toUpperCase() + currentTheme.slice(1);
        statusText.textContent = `${mode}, ${theme} Theme`;
    }
};

onMounted(() => {
    updateStatus();
    }
)

</script>

<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-blockeditor/styles/tailwind3.css';
</style>
<template>
  <div id='container'>
    <ejs-blockeditor id="blockeditor" :blocks="blocksData" ref="blockEditor" @focus="focusEvent" @blur="blurEvent"></ejs-blockeditor>
    <div id="controls">
            <h3>Appearance Configuration Demo</h3>
            <div class="button-group">
                <button @click="toggleReadonly">Toggle Readonly Mode</button>
                <button @click="applyCustomTheme">Apply Custom Theme</button>
            </div>
            <div class="status-info">
                <p><strong>Current Status:</strong> <span id="statusText">Editable, Default Theme</span></p>
            </div>
        </div>
    <div id="output"></div>
  </div>
</template>

<script>
import { BlockEditorComponent, ContentType } from "@syncfusion/ej2-vue-blockeditor";

export default {
  components: {
    'ejs-blockeditor': BlockEditorComponent,
  },
  data() {
    return {
      blocksData: [
        {
          blockType: 'Heading',
          properties: { level: 1},
          content: [{ contentType: ContentType.Text, content: 'Appearance Configuration Demo' }],
        },
        {
          blockType: 'Paragraph',
          content: [{ contentType: ContentType.Text, content: 'This demo showcases different appearance configurations including readonly mode and a custom CSS theme.' }],
        },
        {
          blockType: 'Heading',
          properties: { level: 2},
          content: [{ contentType: ContentType.Text, content: 'Configured Custom Theme' }],
        },
        {
          blockType: 'BulletList',
          content: [{ contentType: ContentType.Text, content: 'Gradient background with modern styling' }],
        },
        {
          blockType: 'Paragraph',
          content: [{ contentType: ContentType.Text, content: 'Use the readonly toggle to switch between editable and read-only modes. In readonly mode, you can view content but cannot make changes.' }],
        }
      ],
      isReadonly : false,
      currentTheme : 'default'
    };
  },
  methods: {
    toggleReadonly: function() {
      this.isReadonly = !this.isReadonly;
      this.$refs.blockEditor.ej2Instances.readOnly = this.isReadonly;
      const editorElement = document.getElementById('blockeditor')
      if (editorElement) {
        if(this.isReadonly){
            editorElement.classList.add('readonly-mode');
        }
        else{
            editorElement.classList.remove('readonly-mode');
        }
      }
      this.updateStatus();
      this.displayOutput(`Readonly mode ${this.isReadonly ? 'enabled' : 'disabled'}. ${this.isReadonly ? 'Content is now view-only.' : 'Content is now editable.'}`);
    },
    applyCustomTheme: function() {
      this.$refs.blockEditor.ej2Instances.cssClass = 'custom-theme';
      this.currentTheme= 'custom';
      this.updateStatus();
      this.displayOutput('Custom theme applied. The editor now features a gradient background with modern styling and hover effects.');
    },
    focusEvent: function() {
      this.displayOutput('Editor focused. You can now type or edit content.');
    },
    blurEvent: function() {
        this.displayOutput('Editor lost focus.');
    },
    updateStatus: function() {
       const statusText = document.getElementById('statusText');
        if (statusText) {
            const mode = this.isReadonly ? 'Readonly' : 'Editable';
            const theme = this.currentTheme.charAt(0).toUpperCase() + this.currentTheme.slice(1);
            statusText.textContent = `${mode}, ${theme} Theme`;
        }
    },
    displayOutput: function(message) {
      var outputDiv = document.getElementById('output');
      if (outputDiv) {
          outputDiv.textContent = message;
      }
    }
  },
  mounted() {
    this.updateStatus();
  }
};
</script>

<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-blockeditor/styles/tailwind3.css';
</style>